import UIKit
import Flutter
import UserNotifications
import KarteCore

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {

  override func application(
    _ application: UIApplication,
    didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
  ) -> Bool {
    GeneratedPluginRegistrant.register(with: self)
    KarteApp.setLogLevel(.debug)
    KarteApp.setup()

    if #available(iOS 10.0, *) {
      print("Use UserNotification.framework")
      UNUserNotificationCenter.current().delegate = self
    }
    return super.application(application, didFinishLaunchingWithOptions: launchOptions)
  }
    
  @available(iOS 10.0, *)
  override func userNotificationCenter(_ center: UNUserNotificationCenter, willPresent notification: UNNotification, withCompletionHandler completionHandler: @escaping (UNNotificationPresentationOptions) -> Void) {
    // display notification even app is foreground.
    completionHandler([.alert])
    // call firebase_messaging swizzled method.
    super.userNotificationCenter(center, willPresent: notification, withCompletionHandler: (completionHandler))
  }
}
